# Totally Versatile Miscellania for PyTorch

*Thomas Viehmann* <tv@lernapparat.de>

This repository collects various things I have implmented for PyTorch

## Layers, autogra functions and calculations

- [2d Wavelet Transformation using PyTorch convolutions and coefficents from PyWavelet](misc/2D-Wavelet-Transform.ipynb)
- [Implicit Function Theorem and Implicit Functions in PyTorch](misc/Implicit_Functions_Pytorch.ipynb)
- [Wasserstein Distance of Histograms/Distributions](wasserstein-distance/Pytorch_Wasserstein.ipynb)

## Learning approaches

- [Gaussian Process Regression](misc/gaussian_process_regression_basic.ipynb) see also [candlegp](https://github.com/t-vi/candlegp), a more complete GP library for PyTorch
- [1d Gaussian Mixture Density Networks](misc/Mixture_Density_Network_Gaussian_1d.ipynb)

## Generative Adversarial Networks

Wasserstein GAN - See also my two [blog](http://lernapparat.de/improved-wasserstein-gan/) [posts](http://lernapparat.de/more-improved-wgan/)
on the subject

- [Semi-Improved Training of Wasserstein GAN](wasserstein-distance/Semi-Improved_Training_of_Wasserstein_GAN.ipynb)
- [Improved Training of Wasserstein GAN](wasserstein-distance/Improved_Training_of_Wasserstein_GAN.ipynb)
